#include ".h"
#include <unordered_set>

using namespace std;

bool ::hasCycle(ListNode* head) {
	unordered_set<ListNode*> seen;
	while (head != nullptr) {
		if (seen.count(head))
			return true;
		seen.insert(head);
		head = head->next;
	}
	return false;
}

ListNode* ::mergeTwoLists(ListNode* list1, ListNode* list2) {
	if (list1 == nullptr)
		return list2;
	if (list2 == nullptr)
		return list1;
	if (list1->val < list2->val)
	{
		list1->next = mergeTwoLists(list1->next, list2);
		return list1;
	}
	else {
		list2->next = mergeTwoLists(list1, list2->next);
		return list2;
	}
}